if (not HealIncTimer) then return end

local Bars = HealIncTimer:NewModule("Bars", "AceEvent-3.0")
local methods = {"LoadVisual", "ClearTimers", "CreateTimer", "DelayTimer", "RemoveTimer"}
local GTBLib

-- PUBLIC METHODS
-- Create our main display frame
function Bars:CreateDisplay()
	local group = GTBLib:RegisterGroup("HealIncTimer", HealIncTimer.media:Fetch(HealIncTimer.media.MediaType.STATUSBAR, HealIncTimer.db.profile.texture))
	group:RegisterOnMove(Bars, "OnBarMove")

	if (HealIncTimer.db.profile.position) then
		group:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", HealIncTimer.db.profile.position.x, HealIncTimer.db.profile.position.y)
	end
	
	return group
end

function Bars:OnBarMove(parent, x, y)
	if (not HealIncTimer.db.profile.position) then
		HealIncTimer.db.profile.position = {}
	end

	HealIncTimer.db.profile.position.x = x
	HealIncTimer.db.profile.position.y = y
end

-- Return an object to access our visual style
function Bars:LoadVisual()
	GTBLib = LibStub:GetLibrary("GTB-1.0-stfx")

	local obj = {}
	for _, func in pairs(methods) do
		obj[func] = self[func]
	end
	
	-- Create anchors
	obj.group = Bars:CreateDisplay(name)
	
	return obj
end

-- Clear all running timers
function Bars:ClearTimers()
	self.group:UnregisterAllBars()
end

-- Create a new timer
function Bars:CreateTimer(id, text, startTime, endTime, icon)
	self.group:RegisterBar(id, text, startTime, endTime, icon)
end

function Bars:DelayTimer(id, endTime)
	self.group:SetTime(id, endTime)
end

function Bars:RemoveTimer(id)
	return self.group:UnregisterBar(id)
end
